<?
/*****
this document should handle all of the following:
 - the default blurb page that one would receive when they first go to this URL
 - the login form when they select that option
 - the main screen one should see once they are logged in.

Note that there will be a toolbar of options available to the user once they
are logged in. That toolbar should be included from another file.  This way,
all forms presented once logged in can include that toolbar, making it very
easy to navigate the site.
*****/
define(_THISFILE, "index.php");
include("connectdb.php");
include("security.php");
include("toolbar.php");
include("constants.php");

$security_cookie = $_COOKIE[_COOKIE_NAME];

if(connect_db()){
	switch($_POST["index_action"]){
		case "View Data":
			break;
		case "Log In":
			if($_POST["section_name"] == "authenticate"){
				handle_authentication();
			}else{
				draw_header(_PROJECT_NAME." - Login");
				login_form();
				draw_footer();
			}
			break;
		case "logout":
			$uid = get_id_from_cookie($security_cookie);
			delete_login_cookie($uid);
			setcookie(_COOKIE_NAME, $security_cookie, time() -1);
			draw_header(_PROJECT_NAME);
			draw_default_page();
			draw_footer();
			break;
		case "mainmenu":
			/*** Check the cookie, see if they're logged in, and act accordingly. ***/
			if(check_login_cookie($security_cookie, $_SERVER["REMOTE_ADDR"])){
				/*** The cookie looks good.  Grab the user ID and touch the cookie. ***/
				$uid = get_id_from_cookie($security_cookie);
				setcookie(_COOKIE_NAME, $security_cookie, touch_login_cookie($uid));
				draw_header(_PROJECT_NAME." - Menu");
				draw_mainmenu($uid);
				draw_footer();
			}else{
				draw_header(_PROJECT_NAME." - Login");
				login_form();
				draw_footer();
			}
			break;
		default:
			draw_header(_PROJECT_NAME);
			draw_default_page();
			draw_footer();
	}
}else{
	draw_header(_PROJECT_NAME." - Error");
?>
	<h2>Error</h2>
	<p>Unable to connect to the database. Please contact the system administrator.</p>
<?
	draw_footer();
}

function draw_header($page_title){
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.0 Transitional//EN">
<html>
<head>
        <meta name="copyright" content="Copyright 2005, Jacob A. Ewing">
        <title><?echo $page_title?></title>
	<link rel=stylesheet href="presentation.css" type="text/css">
	<!--style type=text/css>
		body{
			background-image: url("sportlog_header.jpg");
			background-repeat: no-repeat;
		}
	</style-->
</head>
<body>
<?
}

function draw_footer(){
?>	
	</body>
	</html>
<?php
}

function draw_default_page(){
?>
	<p class=centered>
		<img src="Sportlog_header2.png" alt="SportLog">
	</p>
	<p>This page is designed as a multi-user data tracker that can be
	used to collect, share, view, and modify personal statistics in
	various racing sports.  Initially designed for keeping track of
	personal cycling statistics, that is what it suits best.  It will
	however work very well for running, swimming, skating, or any
	other race-oriented sport in which one can track their data.</p>
	<table>
		<tr>
			<td><form method=post action=<?echo _THISFILE?>><input type=submit name="index_action" value="Log In"></form></td>
			<td>if you already have an account.</td>		
		</tr><tr>
			<td><form method=post action="signup.php"><input type=submit name="index_action" value="Sign Up"></form></td>
			<td>if you do not already have an account and would like one.</td>
		</tr><tr>
			<td><form method=post action=<?echo _THISFILE?>><input type=submit name="index_action" value="View Data" disabled></form></td>
			<td>if you would like to view statistics shared by other users.</td>
		</tr>
	</table>
	<p class=centered>
	<a href="http://www.spreadfirefox.com/?q=affiliates&amp;id=91487&amp;t=64"><img border="0" alt="Get Firefox!" title="Get Firefox!" src="http://sfx-images.mozilla.org/affiliates/Buttons/110x32/get.gif"/></a>
	</p>
<?
}

function login_form($username = ""){
?>
	<form method=post action=<?echo _THISFILE?>>
	<table class=login_table>
		<thead class=login_head>
			<td colspan=2><?echo _PROJECT_NAME?> User Login</td>
		</thead>
		<tr>
			<td>Username:</td>
			<td><input type=text name="login_username"<?
			if($username != ""){
				echo " value=\"".$username."\"";
			}
			?>></td>
		</tr>
		<tr>
			<td>Password:</td>
			<td><input type=password name="login_password"><td>
		</tr>
		<tr>
			<td><input type=submit name="index_action" value="Log In"></td>
		</tr>
	</table>
	<input type=hidden name="section_name" value="authenticate">
	</form>
<?
}

function handle_authentication(){
	$username = $_POST["login_username"];
	$password = $_POST["login_password"];
	if(validate_password($username, $password)){
		$user_id = read_user_id($username);
		create_login_cookie($user_id, $cvalue);
		setcookie(_COOKIE_NAME, $cvalue, time() + 3600);
		draw_header(_PROJECT_NAME." - Menu");
		draw_mainmenu($user_id);
		draw_footer();
	}else{
		draw_header(_PROJECT_NAME." - Login");
		echo "<h3>Invalid username or password</h3>";
		login_form($username);
		draw_footer();
	}
}

function draw_mainmenu($user_id){
	/*** get the user information ***/
	$query = "SELECT * FROM users WHERE user_id=".$user_id;
	$user_data = mysql_fetch_array(mysql_query($query));
	$permissions = $user_data["permissions"];
	$name = $user_data["name"];
	echo "<h3>What would you like to do ".$name."?</h3>\n";
	draw_toolbar($user_id);
}
?>
