<?php
error_reporting(E_ALL);
/********** Include the local libraries **************/
include("constants.php");
include("connectdb.php");

/********************* Definitions ******************/
define("_THIS_FILENAME", "signup.php");
define("_RESERVATION_KEY_LENGTH", "16");
define("_SIGNUP_EXPIRY_HOURS", "48");

/*** The following definitions are error bitflags.  Each group of them
corresponds to a step in the wizard.  These will of course change with each
implementation of this library *****/
define("_ERR_NO_NAME_SPECIFIED", "1");
define("_ERR_UNMATCHED_EMAIL", "2");
define("_ERR_INVALID_EMAIL", "4");

define("_ERR_NO_QUESTION", "1");
define("_ERR_NO_ANSWER", "2");

define("_ERR_NO_USERNAME_SPECIFIED", 1);
define("_ERR_NO_PASSWORD_SPECIFIED", 2);
define("_ERR_UNMATCHED_PASSWORD", 4);
define("_ERR_USERNAME_DB_CONNECT", 8);
define("_ERR_USERNAME_EXISTS", 16);
define("_ERR_USERNAME_RESERVED", 32);
define("_ERR_RESERVING_USERNAME", 64);

/********************* Classes *******************/
class stepclass{
	var $title = NULL;
	var $errorflags = 0;
	var $drawfunction = NULL;
	var $testfunction = NULL;
	var $postfunction = NULL;

	function init($newdrawfunction = NULL, $newtestfunction = NULL, $newpostfunction = NULL){
		$this->drawfunction = $newdrawfunction;
		$this->testfunction = $newtestfunction;
		$this->postfunction = $newpostfunction;
	}

	/*** These next functions each call another function that's set in the
	main body of the code.  This makes the code more dynamic and more easily
	automated, and throws in error-checking to boot.  ***/

	/*** Draw the form to the browser ***/
	function draw($arg = NULL){
		if($this->drawfunction != NULL){
			call_user_func($this->drawfunction, $arg);
		}
	}

	/*** Test the data submited with this object. **/
	function test($arg = NULL){
		$returnval = 0;
		if($this->testfunction != NULL){
			$returnval = call_user_func($this->testfunction, $arg);
		}
		return $returnval;
	}

	/*** re-post data that has been submitted to this step already ***/
	function post($arg = NULL){
		if($this->postfunction != NULL){
			call_user_func($this->postfunction, $arg);
		}
	}
}

class wizardclass{
	var $numsteps = 0;
	var $current_step = 0;
	var $step;
	function addstep($drawfunction = NULL, $testfunction = NULL, $postfunction = NULL){
		$this->step[$this->numsteps] = new stepclass;
		$this->step[$this->numsteps]->init($drawfunction, $testfunction, $postfunction);
		$this->numsteps++;
	}
}

$signup_wizard = new wizardclass;
$signup_wizard->addstep("draw_welcome_step");
$signup_wizard->addstep("draw_contact_step", "test_contact_step", "post_contact_step_data");
$signup_wizard->addstep("draw_username_step", "test_username_step", "post_username_step_data");
$signup_wizard->addstep("draw_challenge_step", "test_challenge_step", "post_challenge_step_data");
$signup_wizard->addstep("draw_finish_step");

/********* Draw the web page (equivalent to "main" in C) *********/
start_page();
draw_header();

if(array_key_exists("confirmation", $_GET)){
	confirm_signup(stripslashes($_GET["confirmation"]));
}else{
	draw_body();
}

draw_footer();

/********************** Function definitions *******************/
function confirm_signup($reservation_key){
	echo "<body><p>";
	if(connect_db()){
		$query = "SELECT COUNT(*) from signups WHERE reservation_key=\"".$reservation_key."\"";
		$data = mysql_fetch_array(mysql_query($query));
		if($data["COUNT(*)"] != "0"){
			$query = "SELECT * from signups WHERE reservation_key=\"".$reservation_key."\"";
			$data = mysql_fetch_array(mysql_query($query));

			/** Everything checks out.  Now move the data from the reservation
			table into the users table, making this a working account. **/
			$query = "INSERT INTO users (login, password, permissions, name, email, challenge_question, challenge_answer) ";
			$query .= "VALUES (";
			$query .= "\"".$data["login"]."\", ";
			$query .= "encode(\"".$data["password"]."\", \"".$data["password"]."\"), ";
			$query .= _DEFAULT_PERMISSIONS.", ";
			$query .= "\"".$data["name"]."\", ";
			$query .= "\"".$data["email"]."\", ";
			$query .= "\"".$data["challenge_question"]."\", ";
			$query .= "\"".$data["challenge_answer"]."\")";
			mysql_query($query);

			/* Ok, it's been copied into the "users" table.  Now remove it from signups */
			mysql_query("DELETE from signups WHERE reservation_key=\"".$reservation_key."\"");

?>			<p>Your account on <?php echo _PROJECT_NAME; ?> is now active!  To start tracking
			your information, just log in through <a href="index.php">the main page</a>.</p>
<?php		}else{ /*** The reservation is not found ***/
?>			<p>Sorry, the reservation you submitted has not been found in the
			signup database.  If you made this reservation more than
			<?php echo _SIGNUP_EXPIRY_HOURS; ?> hours ago, it may have expired.</p>
			<p>If you wish to sign up for an account on <?php echo _PROJECT_NAME; ?>,
			please go to our <a href="<?php echo _THIS_FILENAME; ?>">signup wizard</a>
			and enter all of the required information.</p>
<?php		}
	}else{
		/** unable to connect to the database. **/
	}
	echo "</body>";
}

function draw_body(){
	global $signup_wizard;
	global $reservation_key;
	$reservation_key = NULL;
	$errcode = 0;
	$action = getpost("action");
	$step_submitted = getpost("stepnumber");

	/** Validate the data submitted **/
	switch(strtolower($action)){
		case "next":
			$errcode = $signup_wizard->step[$step_submitted]->test();
			if($errcode){
				$current_step = $step_submitted;
			}else{
				$current_step = $step_submitted + 1;
			}
			break;
		case "back":
			$current_step = $step_submitted - 1;
			if($current_step < 0) $current_step = 0;
			break;
		case "cancel":
			$current_step = $step_submitted;
			$c = strtolower(getpost("confirmcancel"));
			if($c == "yes"){
				$action = "cancelled";
			}else if($c == "no"){
				$action = "next";
			}
			break;
		case "finish":
			$current_step = $step_submitted + 1;
			break;
		case "help":
			break;
		default:
			$current_step = 0;
	}

	/** draw the main body **/
	echo "<body>\n";
	echo "\t<table class=\"centered\"><tr><td></td><td class=\"narrow\"><!-- This centers our \"Window\" -->\n";
	echo "\t\t<form action=\""._THIS_FILENAME."\" method=\"post\">\n";
	switch(strtolower($action)){
		case "finish":
			save_signup_info();
			send_confirmation();
			say_thanks();
			break;
		case "cancel":
			confirm_cancellation();
			break;
		case "cancelled":
			echo "<p>OK, G'bye!</p>\n";
			break;
		default:
			if($current_step >= 0 && $current_step < $signup_wizard->numsteps){
				$signup_wizard->step[$current_step]->draw($errcode);
			}
	}
	/*** Add some extra data **/
	echo "<input type=\"hidden\" name=\"stepnumber\" value=\"".$current_step."\"/>\n";
	// This chunk is unique to the sportlog signup, not part of the wizard library
	if($reservation_key == NULL) $reservation_key = getpost("reservation_key");
	if($reservation_key != NULL){
		echo "<input type=\"hidden\" name=\"reservation_key\" value=\"".$reservation_key."\"/>\n";
	}
	
	/*** Add the data that's been submitted in other steps ***/
	for($n = 0; $n < $signup_wizard->numsteps; $n++){
		if($n != $current_step || strtolower($action) == "cancel"){
			$signup_wizard->step[$n]->post();
		}
	}
	echo "\t\t</form>\n";
	echo "\t</td><td></td></tr></table>\n";
	echo "</body>\n";
}

function save_signup_info(){
	$name = getpost("contact_step_name");
	$email = getpost("contact_step_email");
	$username = getpost("username_step_username");
	$password = getpost("username_step_password");
	$challenge_question = getpost("challenge_step_question");
	$challenge_answer = getpost("challenge_step_answer");
	$reservation_key = getpost("reservation_key");

	if($name && $email && 
	   $username && $password && 
	   $challenge_question && $challenge_answer &&
	   $reservation_key)
	{
		if(connect_db()){
			/** We still have all our data, verify that it's not hacked **/
			$query = "SELECT COUNT(*) from signups WHERE reservation_key=\"".$reservation_key."\" AND ";
			$query .= "login=\"".$username."\"";
			$data = mysql_fetch_array(mysql_query($query));
			if($data["COUNT(*)"] != "0"){
				/* Looks good, go ahead and update the signup table **/
				$query = "UPDATE signups set ";
				$query .= "password=\"".$password."\", ";
				$query .= "name=\"".$name."\", ";
				$query .= "email=\"".$email."\", ";
				$query .= "challenge_question=\"".$challenge_question."\", ";
				$query .= "challenge_answer=\"".$challenge_answer."\", ";
				$query .= "expiry_time=".(time() + 3600 * _SIGNUP_EXPIRY_HOURS)." ";
				$query .= "WHERE reservation_key=\"".$reservation_key."\"";

				mysql_query($query);

			}else{
				/* Not finding it, something weird, maybe a hack */
			}
		}else{
			/* unable to connect to the database */
		}
	}
}

function confirm_cancellation(){
?>
	<table class="wizard_table">
		<thead class="wizard_head">
			<tr><td colspan="2">Confirm Cancellation</td></tr>
		</thead>
		<tr>
			<td>Are you sure you want to cancel this signup wizard?</td>
		</tr><tr>
			<td>
				<input type="hidden" name="action" value="Cancel">
				<table class="centered"><tr>
					<td><input type="submit" name="confirmcancel" value="Yes"/></td>
					<td><input type="submit" name="confirmcancel" value="No"/></td>
				</tr></table>
			</td>
		</tr>
	</table>
<?php
}

function say_thanks(){
?>	<p>Thanks for signing up!  A confirmation e-mail will shortly be sent to you
	at the e-mail address you specified.  To finish activating your account, simply
	follow the instructions in that e-mail.</p>
	<p>Please note that if you do not activate your account within <?php echo _SIGNUP_EXPIRY_HOURS; ?>
	hours, the username you chose will no longer be reserved and you will need to sign
	up again.</p>
	<p><a href="index.php">Return to the main page</a></p>
<?php
}

function send_confirmation(){
	$email = getpost("contact_step_email");
	$username = getpost("username_step_username");

	$confirmation_link = "http://sportlog.weirdly.net/signup.php?confirmation=".getpost("reservation_key");
	$email_body = "<html><body>\n";
	$email_body .= "<p>Welcome to "._PROJECT_NAME."!  This is a confirmation e-mail which ";
	$email_body .= "is sent to confirm that you actually do wish to sign up for the use ";
	$email_body .= "of our page.  If this e-mail was sent to you in error, please delete it ";
	$email_body .= "and accept our apologies for any inconvenience.</p>\n";
	$email_body .= "<p>The last step to opening your account with us is to go to ";
	$email_body .= "<a href=\"".$confirmation_link."\">".$confirmation_link."</a>. ";
	$email_body .= "Once you have opened that page, your account will be activated and you ";
	$email_body .= "can begin using the database to track your statistics.  If you do not ";
	$email_body .= "open this link within "._SIGNUP_EXPIRY_HOURS." hours, the username you ";
	$email_body .= "have reserved, \"".$username."\", will once again be available for other ";
	$email_body .= "people to choose.</p>";
	$email_body .= "</body></html>";

	mail(	$email,
		_PROJECT_NAME." Signup Confirmation",
		$email_body,
		"From: Sportlog Signup <sportlog@weirdly.net>\r\nMIME-Version: 1.0\r\nContent-Type: text/html; charset=ISO-8859-1\r\nContent-Transfer-Encoding: 8bit\r\n"
	);
}
/****************************** Wizard Steps *******************************
The functions in this part of the script will each be used for drawing or
testing individual steps in the wizard.  This means that they will change
with the purpose of the code.
***************************************************************************/
function draw_contact_step($errcode = 0){
?>
	<table class="wizard_table">
		<thead class="wizard_head">
			<tr><td colspan="2"><?php echo _PROJECT_NAME; ?> Signup</td></tr>
		</thead>
		<tr>
			<td>
<?php				if(!$errcode){ /* The default paragraph at the top of this step */
?>
					<p>To begin, please enter your name, and an e-mail
					address at which we can contact you to confirm your account
					information:</p>
<?php				}else{
					/**
					We've hit this if condition because the data submitted did not
					pass the error check.  Explain to the user what they've done wrong
					**/
					echo "<ul class=\"leftalign\">\n";
					if($errcode & _ERR_NO_NAME_SPECIFIED){
?>						<li>You have not entered your name.  Please enter it
						in the "Name:" field below</li>
<?php					}
					if($errcode & _ERR_UNMATCHED_EMAIL){
?>						<li>The e-mail addresses you entered do not match.  Please
						check the "Your e-mail address" and
						"Confirm your e-mail address:" fields below and
						correct any errors they may contain.</li>
<?php					}else if($errcode & _ERR_INVALID_EMAIL){
?>						<li>The e-mail address you entered does not appear to be a
						valid one.  Please check the address you have entered below
						and verify that it is entered correctly.</li>
<?php					}
					echo "</ul>\n";
				}
?>
				<table class="centered">
					<tr>
						<td class="fieldlabel">Name:</td>
						<td><input type="text" name="contact_step_name" value="<?php echo getpost("contact_step_name"); ?>"/></td>
					</tr><tr>
						<td class="fieldlabel">Your e-mail address:</td>
						<td><input type="text" name="contact_step_email" value="<?php echo getpost("contact_step_email"); ?>"/></td>
					</tr><tr>
						<td class="fieldlabel">Confirm your e-mail address:</td>
						<td><input type="text" name="contact_step_confirm_email" value="<?php echo getpost("contact_step_confirm_email"); ?>"/></td>
					</tr>
				</table>

			</td>
		</tr><tr>
			<td>
				<table class="centered"><tr>
					<td><input type="submit" name="action" value="Back"/></td>
					<td><input type="submit" name="action" value="Next"/></td>
					<td><input type="submit" name="action" value="Cancel"/></td>
				</tr></table>
			</td>
		</tr>
	</table>
<?php
}

function test_contact_step(){
	$returnval = 0;
	$contact_step_name = getpost("contact_step_name");
	$contact_step_email = getpost("contact_step_email");
	$contact_step_confirm_email = getpost("contact_step_confirm_email");
	if(strlen($contact_step_name) <= 0) $returnval |= _ERR_NO_NAME_SPECIFIED;
	if(strcmp($contact_step_email, $contact_step_confirm_email)) $returnval |= _ERR_UNMATCHED_EMAIL;
	if(validate_email_address($contact_step_email)) $returnval |= _ERR_INVALID_EMAIL;
	return $returnval;
}

function post_contact_step_data(){
	echo "<input type=\"hidden\" name=\"contact_step_name\" value=\"".getpost("contact_step_name")."\"/>\n";
	echo "<input type=\"hidden\" name=\"contact_step_email\" value=\"".getpost("contact_step_email")."\"/>\n";
	echo "<input type=\"hidden\" name=\"contact_step_confirm_email\" value=\"".getpost("contact_step_confirm_email")."\"/>\n";
}

function draw_username_step($errcode = 0){
?>
	<table class="wizard_table">
		<thead class="wizard_head">
			<tr><td colspan="2"><?php echo _PROJECT_NAME; ?> Signup</td></tr>
		</thead>
		<tr>
			<td>
<?php				if(!$errcode){ /* The default paragraph at the top of this step */
?>
					<p>Please choose a username and password that you will use to log into
					this system.  Both the username and password should be made strictly of
					letters or numbers, and must not contain any other symbols such as hyphens,
					underscores, apostrophes, etc.</p>
<?php				}else{
					/**
					We've hit this if condition because the data submitted did not
					pass the error check.  Explain to the user what they've done wrong
					**/
					echo "<ul class=\"leftalign\">\n";
					if($errcode & _ERR_NO_USERNAME_SPECIFIED){
?>						<li>You have not selected a username.  Please
						enter one in the "Username" field below.</li>
<?php					}
					if($errcode & _ERR_UNMATCHED_PASSWORD){
?>						<li>The "Password" and "Confirm Password" fields
						do not match.  Please re-enter them, remembering that
						that are case-sensitive and should not contain any
						non alpha-numeric characters.</li>
<?php					}else if($errcode & _ERR_NO_PASSWORD_SPECIFIED){
?>						<li>You have not specified a password.  Please choose a password
						that you will be able to remember, but which other people are
						not likely to guess, and enter it in both the "Password" and
						"Confirm Password" fields below.</li>
<?php					}
					if($errcode & _ERR_USERNAME_DB_CONNECT){
?>						<li>We are currently having problems with the database
						server and can not check to see if the selected username
						already exists.  We apologize for any inconvenience this causes,
						but please do try again later.</li>
<?php					}
					if($errcode & _ERR_USERNAME_EXISTS){
?>						<li>The username you have chosen is already in use.
						Please choose a different one.</li>
<?php					}
					if($errcode & _ERR_USERNAME_RESERVED){
?>						<li>The username you have chosen is already reserved by
						another user.  Please choose a different one.</li>
<?php					}
					if($errcode & _ERR_RESERVING_USERNAME){
?>						<li>There was an error reserving the username you have selected.
						Please choose a different one.</li>
<?php					}
					echo "</ul>\n";
				}
?>
				<table class="centered">
					<tr>
						<td class="fieldlabel">Username:</td>
						<td><input type="text" name="username_step_username" value="<?php echo getpost("username_step_username"); ?>"/></td>
					</tr><tr>
						<td class="fieldlabel">Password:</td>
						<td><input type="password" name="username_step_password" value="<?php echo getpost("username_step_password"); ?>"/></td>
					</tr><tr>
						<td class="fieldlabel">Confirm Password:</td>
						<td><input type="password" name="username_step_confirm_password" value="<?php echo getpost("username_step_confirm_password"); ?>"/></td>
					</tr>
				</table>

			</td>
		</tr><tr>
			<td>
				<table class="centered"><tr>
					<td><input type="submit" name="action" value="Back"/></td>
					<td><input type="submit" name="action" value="Next"/></td>
					<td><input type="submit" name="action" value="Cancel"/></td>
				</tr></table>
			</td>
		</tr>
	</table>
<?php
}

function test_username_step(){
	/** TO DO:
		Before all of the queries are made about the selected username, the signups
		list should be "cleaned".  That is to say, it should check for any signups
		that have been reserved more than X hours ago and which have not yet been
		confirmed.  If any meet those qualifications, they should be dropped from
		the table.
	**/
	GLOBAL $reservation_key;
	$reservation_key = getpost("reservation_key");
	$returnval = 0;
	$username_step_username = strtolower(getpost("username_step_username"));
	$username_step_password = getpost("username_step_password");
	$username_step_confirm_password = getpost("username_step_confirm_password");
	if(connect_db()){
		if(strlen($username_step_username) <= 0) $returnval |= _ERR_NO_USERNAME_SPECIFIED;
		if(strlen($username_step_password) <= 0) $returnval |= _ERR_NO_PASSWORD_SPECIFIED;
		if(strcmp($username_step_password, $username_step_confirm_password)) $returnval |= _ERR_UNMATCHED_PASSWORD;
	}else{
		$returnval |= _ERR_USERNAME_DB_CONNECT;
	}

	if(!($returnval & _ERR_NO_USERNAME_SPECIFIED)){
		/** They have entered a username, check to see if it's in use already **/
		/** Check existing users first **/
		$data = mysql_fetch_array(mysql_query("SELECT COUNT(login) FROM users WHERE login=\"".$username_step_username."\""));
		if($data["COUNT(login)"] != "0"){
			$returnval |= _ERR_USERNAME_EXISTS;
		}
	}

	if(!($returnval & (_ERR_NO_USERNAME_SPECIFIED | _ERR_USERNAME_EXISTS))){
		/** There is a username specified, and it is not yet taken.  Now check
		to see if it's been "reservered" by other people using the wizard **/
		$query = "SELECT COUNT(login) FROM signups WHERE login=\"".$username_step_username."\"";
		if($reservation_key != NULL){
			$query .= " AND reservation_key != \"".$reservation_key."\"";
		}
		$data = mysql_fetch_array(mysql_query($query));
		if($data["COUNT(login)"] != "0"){
			$returnval |= _ERR_USERNAME_RESERVED;
		}
	}

	if(!$returnval){
		/** Everything checks out, go ahead and reserve this username **/
		/** First, check to see if they already have a reservation key **/
		if($reservation_key == NULL){
			/* No reservation key yet. Make one */
			$reservation_key = generate_reservation_key();
		}else{ /* They have already reserved a username, drop it from the reservation table: */
			$query = "DELETE FROM signups WHERE reservation_key=\"".$reservation_key."\"";
			mysql_query($query);
		}

		$query = "INSERT INTO signups (login, reservation_key) VALUES (\"";
		$query .= $username_step_username."\", \"".$reservation_key."\")";
		if(!mysql_query($query)){
			$returnval |= _ERR_RESERVING_USERNAME;
		}
	}

	return $returnval;
}

function generate_reservation_key(){
	$returnval = NULL;
	for($n = 0; $n < _RESERVATION_KEY_LENGTH; $n++){
		$r = rand() % 62;
		if($r < 10){
			$returnval .= chr(ord("0") + $r);
		}else if($r < 36){
			$returnval .= chr(ord("A") + ($r - 10));
		}else{
			$returnval .= chr(ord("a") + ($r - 36));
		}
	}
	return $returnval;
}

function post_username_step_data(){
	echo "<input type=\"hidden\" name=\"username_step_username\" value=\"".getpost("username_step_username")."\"/>\n";
	echo "<input type=\"hidden\" name=\"username_step_password\" value=\"".getpost("username_step_password")."\"/>\n";
	echo "<input type=\"hidden\" name=\"username_step_confirm_password\" value=\"".getpost("username_step_confirm_password")."\"/>\n";
}

function draw_welcome_step(){
?>	<table class="wizard_table">
		<thead class="wizard_head">
			<tr><td colspan="2">Welcome to <?php echo _PROJECT_NAME; ?>!</td></tr>
		</thead>
		<tr>
			<td>
			This wizard will help you sign up for an account on <?php echo _PROJECT_NAME; ?>.
			Once an account is created, you will be able to track your personal sports statistics
			on this server's database.
			</td>
		</tr><tr>
			<td>
				<table class="centered"><tr>
					<td><input type="submit" name="action" value="Next"/></td>
					<td><input type="submit" name="action" value="Cancel"/></td>
				</tr></table>
			</td>
		</tr>
	</table>
<?php
}

function draw_challenge_step($errcode = 0){
?>	<table class="wizard_table">
		<thead class="wizard_head">
			<tr><td colspan="2"><?php echo _PROJECT_NAME; ?> Signup</td></tr>
		</thead>
		<tr>
			<td>
<?php			if(!$errcode){
?>				Please choose a challenge question and answer that we can ask you
				if you forget your password.  It is best to make this something that
				other people are not likely to guess, but which you will not forget (eg.
				"What is your mother's maiden name?"
<?php			}else{
				echo "<ul>\n";
				if($errcode & _ERR_NO_QUESTION){
?>					<li>You have not entered a challenge question.  Please consider
					a question that you will always answer the same way, but which
					other people are not as likely to guess.  For example, "What is
					middle name of your oldest sibling?"</li>
<?php				}
				if($errcode & _ERR_NO_ANSWER){
?>					<li>You have not entered an answer to the challenge question.
					This answer is needed so that we can confirm your identity if
					you loose your password.  Please enter the answer to your challenge
					question.</li>
<?php				}
				echo "</ul>\n";
			}
?>			</td>
		</tr><tr>
			<td>
				<table class="centered">
					<tr>
						<td class="fieldlabel">Challenge Question:</td>
						<td><input type="text" name="challenge_step_question" value="<?php echo getpost("challenge_step_question"); ?>" /></td>
					</tr><tr>
						<td class="fieldlabel">Challenge Answer:</td>
						<td><input type="text" name="challenge_step_answer" value="<?php echo getpost("challenge_step_answer"); ?>" /></td>
					</tr>
				</table>
			</td>
		</tr><tr>
			<td>
				<table class="centered"><tr>
					<td><input type="submit" name="action" value="Back"/></td>
					<td><input type="submit" name="action" value="Next"/></td>
					<td><input type="submit" name="action" value="Cancel"/></td>
				</tr></table>
			</td>
		</tr>
	</table>
<?php
}

function test_challenge_step(){
	$returnval = 0;
	if(getpost("challenge_step_question") == NULL) $returnval |= _ERR_NO_QUESTION;
	if(getpost("challenge_step_answer") == NULL) $returnval |= _ERR_NO_ANSWER;
	return $returnval;
}

function post_challenge_step_data(){
	echo "<input type=\"hidden\" name=\"challenge_step_question\" value=\"".getpost("challenge_step_question")."\"/>\n";
	echo "<input type=\"hidden\" name=\"challenge_step_answer\" value=\"".getpost("challenge_step_answer")."\"/>\n";
}

function draw_finish_step(){
?>	<table class="wizard_table">
		<thead class="wizard_head">
			<tr><td colspan="2">Confirming Information</td></tr>
		</thead>
		<tr>
			<td>
				<p>All of the information that is needed to create your account has now been
				entered.  Please confirm that information below.  If any of it is incorrect,
				please go back through the wizard and re-enter it appropriately.  When you
				hit the "Finish" button below, an e-mail will be sent to the address you
				have specified.  That e-mail will contain a link to a web page that you
				will need to open in order to confirm your account signup.</p>

				<table class="centered">
					<tr>
						<td class="fieldlabel">Name:</td>
						<td class="leftalign"><?php echo getpost("contact_step_name"); ?></td>
					</tr><tr>
						<td class="fieldlabel">e-mail Address:</td>
						<td class="leftalign"><?php echo getpost("contact_step_email"); ?></td>
					</tr><tr>
						<td class="fieldlabel">Username:</td>
						<td class="leftalign"><?php echo getpost("username_step_username"); ?></td>
					</tr><tr>
						<td class="fieldlabel">Password:</td>
						<td class="leftalign">
<?php							for($n = 0; $n < strlen(getpost("username_step_password")); $n++){
								echo "*";
							}
?>						</td>
					</tr><tr>
						<td class="fieldlabel">Challenge Question:</td>
						<td class="leftalign"><?php echo getpost("challenge_step_question"); ?></td>
					</tr><tr>
						<td class="fieldlabel">Challenge Answer:</td>
						<td class="leftalign"><?php echo getpost("challenge_step_answer"); ?></td>
					</tr>
				</table>
			</td>
		</tr><tr>
			<td>
				<table class="centered"><tr>
					<td><input type="submit" name="action" value="Back"/></td>
					<td><input type="submit" name="action" value="Finish"/></td>
					<td><input type="submit" name="action" value="Cancel"/></td>
				</tr></table>
			</td>
		</tr>
	</table>
<?php
}

/***************** Some handy functions that may be stuck in a library when I'm done here *****************/
/*** Validates an e-mail address.  Returns 0 if it seems valid, or
a bitflag value describing the errors in it (flags noted below) ***/
function validate_email_address($testaddress){
	$returnval = 0;

	/** Error codes **/
	$err_noaddr = 1; // "There IS no spoon!"
	$err_atloc = 2; // The @ is in an invalid position
	$err_dotloc = 4; // a . is in an invalid position
	$err_numats = 8; // incorrect number of at symbols
	$err_numdots = 16; // incorrect number of dots

	if(!strlen($testaddress)){
		/** There is no address specified **/
		$returnval |= $err_noaddr;
	}else{
		$addlen = strlen($testaddress);
		/** Check to make sure there's a single @ and at least one dot in the address **/
		for($n = $numdots =  $numats = 0; $n < $addlen; $n++){
			if($testaddress[$n] == "@"){
				$numats++;
				if($n == 0 || $n > $addlen - 4){
					$returnval |= $err_atloc;
				}
			}
			if($testaddress[$n] == "."){
				$numdots++;
				if($n == 0 || $n > $addlen - 3){
					$returnval |= $err_dotloc;
				}
			}
		}
		if($numats != 1) $returnval |= $err_numats;
		if($numdots < 1) $returnval |= $err_numdots;
	}
	return $returnval;
}

/*** gives the value of the variable posted if it's there, NULL it it's not.  This
is just a quick workaround to avoid errors when referring to $_POST["something"]
values that do not exist.  This error would only show up if PHP is running in
strict error mode. ***/
function getpost($postname){
	if(array_key_exists($postname, $_POST)){
		$returnval = stripslashes($_POST[$postname]);
	}else{
		$returnval = NULL;
	}
	return $returnval;
}

/*************** A few odd functions that draw the header, footer, etc. on the page *****************/
function draw_header(){
?>
<head>
	<title><?php echo _PROJECT_NAME; ?></title>
	<link rel=stylesheet href="presentation.css" type="text/css">
	<style type="text/css">
		.wizard_table{
			background-color: #DDDDEE;
			border: solid;
			border-color: #000000;
			border-width: thin;
			text-align: center;
			margin: 0%;
		}

		table.centered {
			margin: auto;
			text-align: center;
		}

		td.fieldlabel{
			text-align: right;
			font-weight: bold;
			font-size: 90%;
			margin: 0%;
		}

		.leftalign{
			text-align: left;
		}

		.wizard_head{
			text-align: center;
			font: bold 12pt sans-serif;
			color: #000000;
			background-color: #8888AA;
		}

		td.narrow{
			width: 50%;
		}

		body{
			background-color: #FFFFEE;
		}
	</style>
</head>
<?php
}

function draw_footer(){
	echo "</html>\n";
}

function start_page(){
	echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	?><!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<?php
	echo "<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n";
}
?>
